/*****************************************************
Project :    
Version : v.1.0a
Date    : 02.01.2010 - 26.03.2011
Author  :  . . RA4CBH
Company : 
Comments: http://ra4cbh.qrz.ru/


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <delay.h>
#include <stdio.h>
#include "Menu.h"
#include "Menu.c"

#include "zwuk.c"
#include "zwuk.h"


// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm
#include <i2c.h>

// DS1621 Thermometer/Thermostat functions
#include <ds1621.h>

// DS1307 Real Time Clock functions
#include <ds1307.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x1B ;PORTA
#endasm
#include <lcd.h>
                                                     
// Declare your global variables here

#define kzad 3000      
  
void main(void)
{
// Declare your local variables here
 
    
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x08;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=P State1=T State0=T 
PORTC=0x04;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTD=0xDF;     
DDRD=0x20;      

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;       
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=kzad; 
OCR1AL=0x00;  
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;    

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// I2C Bus initialization
i2c_init();

// DS1621 Thermometer/Thermostat initialization
// tlow: -10C
// thigh: 100C
// Tout polarity: 0
ds1621_init(1,-10,100,0);

// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 0
rtc_init(0,0,0);

// LCD module initialization
lcd_init(20);


lcd_clear();

lcd_gotoxy(0,0);         // ( .,  )
lcd_putsf("MHOOHKOHAbHæ"); 
lcd_gotoxy(0,1);         // ( .,  )
lcd_putsf("BOHOK+OXPAHA v.1.0a");
lcd_gotoxy(3,2);         // ( .,  )
lcd_putsf("RA4CBH.QRZ.RU");               //13 
lcd_gotoxy(3,3);         // ( .,  )
lcd_putsf("Aop RA4CBH");                   //12 
 
delay_ms(2000);

PORTB.4=1; 

start();  

print_menu();

// Global enable interrupts
#asm("sei")

       

while (1)
      { 
      PORTA.3=swet;         //
      PORTB.2=ohrana;       // "" (.)     
      PORTB.3=tishina;      // " " (.)

      if (ohrana==-1) {ohrana=0;}
      if (tishina==-1) {tishina=0;}   
      if (swet==-1) swet=0; 
      
            
     if (ohrana==1) ohrana=1;
     if (tishina==1) tishina=1;
     if (swet==1) swet=1;

  rtc_get_time(&hour,&min,&sek);      
  rtc_get_date(&day,&month,&year);  


    if (ohrana==1)
    { if (PINC.2==1) {ohran_prowod();} 
    
    
     if (nav==0) PORTB.1=0;
     else {
     if (sek/2 & sek%2) PORTB.1=1; else PORTB.1=0;     
     }
     
    }
    else PORTB.1=0;
    
      if (tishina==1)
     {
     if (PIND.0==0) PORTB.1=1;      
     }
       
      
      if (current_menu==NASTROJKI_MENU)
      { 
        command_addr=(number_char*8)+0b01000000;
        for (i=0; i<8; i++)
        {lcd_write_byte(command_addr++,galochka[i]);}
        if (nav==0){
        lcd_gotoxy(18,2);
        lcd_putchar(2);}         
            
        if (swet==1)
        {
        lcd_gotoxy(12,3);
        lcd_putsf("[B. ]"); //.
        }
        if (swet==0)
        {
        lcd_gotoxy(12,3);
        lcd_putsf("[Bú.]"); //.
        }
        
       }
     
 
      
  if (current_menu==TIME_MENU) 
 {  lcd_gotoxy(2,0);
    lcd_putchar(hour/10+0x30);
    lcd_putchar(hour%10+0x30);  
    
    lcd_gotoxy(6,0);
    lcd_putsf("ac");  //
    
  //  lcd_putchar(':');
    lcd_gotoxy(2,1);
    lcd_putchar(min/10+0x30);
    lcd_putchar(min%10+0x30);  
    
    lcd_gotoxy(6,1);
    lcd_putsf("My");  //    
 } 
  
   if (current_menu==DATE_MENU) 
 {  lcd_gotoxy(2,0);
    lcd_putchar(day/10+0x30);
    lcd_putchar(day%10+0x30); 
    
    lcd_gotoxy(6,0);
    lcd_putsf("e");  //
    
     lcd_gotoxy(2,1);
    lcd_putchar(month/10+0x30);
    lcd_putchar(month%10+0x30); 
    
    lcd_gotoxy(6,1);
    lcd_putsf("Mec");  //    
    
    lcd_gotoxy(2,2);
    lcd_putchar(year/10+0x30);
    lcd_putchar(year%10+0x30);    
    
    lcd_gotoxy(6,2);
    lcd_putsf("o");  //    
    
    lcd_gotoxy(1,3);
    lcd_putsf("   ");    
 }


      
    if (nav==-1) {nav=0;}  
    if (nav==13) {nav=12;}  

  if (current_menu==MAIN_MENU)
{      
   lcd_gotoxy(15,0);
   lcd_putchar(nav/10+0x30);     
   lcd_putchar(nav%10+0x30);        
   
   if (nav==12)                         
 {  lcd_gotoxy(18,0); 
   lcd_putchar(0x2A); 
   }
   
  
   lcd_gotoxy(0,2);
   lcd_putsf("Teepaypa:");     // 


      temp=ds1621_temperature_10(1);  
      znak=' ';
      if (temp<0)
      {znak='-';
      temp=-temp;};    
      
      sprintf(lcd_buffer, "%c%i.%u\xdfC", znak, temp/10, temp%10);
     
      lcd_gotoxy(13,2);
      lcd_puts(lcd_buffer);
      
      if (temp<-50 | temp>450) rab_temp();      
     

              
   lcd_gotoxy(1,3);
  lcd_putchar(hour/10+0x30);
  lcd_putchar(hour%10+0x30);
  lcd_putchar(':');
  lcd_putchar(min/10+0x30);
  lcd_putchar(min%10+0x30);
  lcd_putchar(':');
  lcd_putchar(sek/10+0x30);
  lcd_putchar(sek%10+0x30);
 
  lcd_gotoxy(11,3);
  lcd_putchar(day/10+0x30);
  lcd_putchar(day%10+0x30);
  lcd_putchar('.');
  lcd_putchar(month/10+0x30);
  lcd_putchar(month%10+0x30);
  lcd_putchar('.');
  lcd_putchar(year/10+0x30);
  lcd_putchar(year%10+0x30);

         
      if (min==60||min==255) {min=0;}      
      if (hour==24||hour==255) {hour=0;}              
}     
  
 
  if (current_menu==OTCHET_MENU)
 {  
 
 if (nav==0)
 {
  lcd_gotoxy(7,1);  
  lcd_putsf("yco");  //
 }
 else
 {  
  lcd_gotoxy(1,0);   
  lcd_puts(mas1); 

  lcd_gotoxy(1,1);  
  lcd_puts(mas2);
 
  lcd_gotoxy(1,2);  
  lcd_puts(mas3);  
  
  lcd_gotoxy(1,3);  
  lcd_puts(mas4); 
           
  }

  }   
 
 
  if(PIND.3==0)
  {
  delay_ms(180);
  kod='u';
  }
  
  if(PIND.6==0)
  {
  delay_ms(180);
  kod='d';
  }
  
  if(PIND.7==0)         
  {
  delay_ms(180);
  kod='e';
  }
  
  if(PIND.4==0)
  {
  delay_ms(180);
  kod='b';
  }               
    
  
  if(PIND.2==0)
  {                                
  delay_ms(180);
  kod='o';
  }  
       
  if(PIND.0==0)                                           
  {if (tishina==0) {PORTB.0=1; delay_ms(180); PORTB.0=0; zwuk();}  
   
  delay_ms(180);

  kod='z';
  }
  else {PIND.5=0; PORTD.5=0;  TCCR1A=0x00; 

TCCR1B=1;       
TCNT1H=0;
TCNT1L=0;
ICR1H=0;
ICR1L=0;
OCR1AH=0;  
OCR1AL=0;  
OCR1BH=0;
OCR1BL=0;
  }  
  
  
  if(PIND.1==0)
  {                                
  delay_ms(180);
  kod='t';
  } 
  
   switch (kod) 
  {
  case 'u':             
  { if (current_poz<=0){current_poz=menu[current_menu].num_selections-1;}
  
  else{current_poz--;}    
  print_menu();
  break;};
  
  case 'd':               
  {if(current_poz>=menu[current_menu].num_selections-1){current_poz=0;}
  else{current_poz++;}      
  print_menu();
  break;};   
  
      
  case 'b': {                      
         
  if (current_menu==OTCHET_MENU){current_menu=MAIN_MENU;}
  
  if (current_menu==NASTROJKI_MENU) 
  {current_menu=MAIN_MENU;}
  if (current_menu==DATE_MENU) current_menu=NASTROJKI_MENU;
  if (current_menu==TIME_MENU) current_menu=NASTROJKI_MENU;
  
  current_poz=last_item;  
             
  print_menu();       
  break;};   
  
  case 'e': {menu[current_menu].m[current_poz].function();    
  print_menu();  
  break;};  
  
  
     
  
  case 'o': {
  if (ohrana==1) {ohrana=0; delay_ms(250);}
  else ohrana=1;
  print_menu();  
  break;};  
  
  case 'z': {
  if (ohrana==1) 
  {       
     nav++;   
     delay_ms(500); 
     
    if (nav==1 || nav==5 || nav==9) sprintf(mas1, "%u %u.%u  %u:%u:%u", nav, day, month, hour, min, sek);
    if (nav==2 || nav==6 || nav==10) sprintf(mas2, "%u %u.%u  %u:%u:%u", nav, day, month, hour, min, sek);
    if (nav==3 || nav==7 || nav==11) sprintf(mas3, "%u %u.%u  %u:%u:%u", nav, day, month, hour, min, sek);
    if (nav==4 || nav==8 || nav==12) sprintf(mas4, "%u %u.%u  %u:%u:%u", nav, day, month, hour, min, sek);   
  }
  print_menu();  
  break;}; 
     
  case 't': {                                     
    if (tishina==1) {tishina=0; delay_ms(250);}
  else tishina=1;
    
  print_menu();  
  break;};  
  
  };  
     };
}

